Package org.optaplanner.core.impl.score.buildin.hardsoftbigdecimal

## Class HardSoftBigDecimalScoreHolderImpl

- java.lang.Object
- - org.optaplanner.core.impl.score.holder.AbstractScoreHolder<HardSoftBigDecimalScore>
  - - org.optaplanner.core.impl.score.buildin.hardsoftbigdecimal.HardSoftBigDecimalScoreHolderImpl

- All Implemented Interfaces:
    `HardSoftBigDecimalScoreHolder`, `ScoreHolder<HardSoftBigDecimalScore>`

      public final class HardSoftBigDecimalScoreHolderImpl
      extends AbstractScoreHolder<HardSoftBigDecimalScore>
      implements HardSoftBigDecimalScoreHolder

  See Also:
    `HardSoftBigDecimalScore`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.BigDecimalMatchExecutor, AbstractScoreHolder.ConstraintActivationUnMatchListener, AbstractScoreHolder.IntMatchExecutor, AbstractScoreHolder.LongMatchExecutor, AbstractScoreHolder.ScoreMatchExecutor<Score_ extends AbstractScore<Score_>>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected BigDecimal` | `hardScore` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.BigDecimalMatchExecutor>` | `matchExecutorByNumberMap` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardSoftBigDecimalScore>>` | `matchExecutorByScoreMap` | Slower than `matchExecutorByNumberMap`
    `protected BigDecimal` | `softScore` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, EMPTY_OBJECT_ARRAY, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HardSoftBigDecimalScoreHolderImpl​(boolean constraintMatchEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeight)` |
    `void` | `addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeight, BigDecimal softWeight)` |
    `void` | `addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal softWeight)` |
    `void` | `configureConstraintWeight​(org.kie.api.definition.rule.Rule rule, HardSoftBigDecimalScore constraintWeight)` |
    `HardSoftBigDecimalScore` | `extractScore​(int initScore)` |
    `BigDecimal` | `getHardScore()` |
    `BigDecimal` | `getSoftScore()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext)` | Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeightMultiplier, BigDecimal softWeightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext)` | Reward a match by the `ConstraintWeight`.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeightMultiplier, BigDecimal softWeightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level.

    - ### Methods inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getIndictmentMap, impactScore, impactScore, impactScore, impactScore, isConstraintMatchEnabled, registerConstraintMatch`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.buildin.hardsoftbigdecimal.HardSoftBigDecimalScoreHolder

      `impactScore`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.BigDecimalMatchExecutor> matchExecutorByNumberMap

    - #### matchExecutorByScoreMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardSoftBigDecimalScore>> matchExecutorByScoreMap

      Slower than `matchExecutorByNumberMap`

    - #### hardScore

          protected BigDecimal hardScore

    - #### softScore

          protected BigDecimal softScore

  - ### Constructor Detail

    - #### HardSoftBigDecimalScoreHolderImpl

          public HardSoftBigDecimalScoreHolderImpl​(boolean constraintMatchEnabled)

  - ### Method Detail

    - #### getHardScore

          public BigDecimal getHardScore()

    - #### getSoftScore

          public BigDecimal getSoftScore()

    - #### configureConstraintWeight

          public void configureConstraintWeight​(org.kie.api.definition.rule.Rule rule,
                                                HardSoftBigDecimalScore constraintWeight)

      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<HardSoftBigDecimalScore>`

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Penalize a match by the `ConstraintWeight` negated.
      Specified by:
        `penalize` in interface `ScoreHolder<HardSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               BigDecimal weightMultiplier)

      Description copied from interface: `HardSoftBigDecimalScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Specified by:
        `penalize` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               BigDecimal hardWeightMultiplier,
                               BigDecimal softWeightMultiplier)

      Description copied from interface: `HardSoftBigDecimalScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level. Slower than `HardSoftBigDecimalScoreHolder.penalize(RuleContext, BigDecimal)`.
      Specified by:
        `penalize` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Reward a match by the `ConstraintWeight`.
      Specified by:
        `reward` in interface `ScoreHolder<HardSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             BigDecimal weightMultiplier)

      Description copied from interface: `HardSoftBigDecimalScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Specified by:
        `reward` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             BigDecimal hardWeightMultiplier,
                             BigDecimal softWeightMultiplier)

      Description copied from interface: `HardSoftBigDecimalScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level. Slower than `HardSoftBigDecimalScoreHolder.reward(RuleContext, BigDecimal)`.
      Specified by:
        `reward` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<HardSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  int weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  long weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### addHardConstraintMatch

          public void addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             BigDecimal hardWeight)

      Specified by:
        `addHardConstraintMatch` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### addSoftConstraintMatch

          public void addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             BigDecimal softWeight)

      Specified by:
        `addSoftConstraintMatch` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### addMultiConstraintMatch

          public void addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                              BigDecimal hardWeight,
                                              BigDecimal softWeight)

      Specified by:
        `addMultiConstraintMatch` in interface `HardSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - never null, higher is better, negative for a penalty, positive for a reward
        `softWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public HardSoftBigDecimalScore extractScore​(int initScore)

      Specified by:
        `extractScore` in class `AbstractScoreHolder<HardSoftBigDecimalScore>`